// ----------------------------------------
// Простейшая немодальная диалоговая панель
// ----------------------------------------

#define STRICT
#include <windows.h>

#define IDB_Button1 1

// Прототипы функций
BOOL InitApp(HINSTANCE);
LRESULT CALLBACK _export WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK    _export DlgProc(HWND, UINT, WPARAM, LPARAM);

// Имя класса окна
char const szClassName[]   = "DialogNMAppClass";

// Заголовок окна
char const szWindowTitle[] = "Modeless Dialog Box";

// Идентификатор окна диалоговой панели
HWND    hwndDlg;

// Идентификатор главного окна приложения
HWND    hwndMain;

HINSTANCE hInst;

// =====================================
// Функция WinMain
// =====================================
#pragma argsused

int PASCAL
WinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR     lpszCmdLine, 
	int       nCmdShow)   
{
  MSG  msg;   // структура для работы с сообщениями

  HWND hButton1;

  // Инициализируем приложение
  if(!InitApp(hInstance))
      return FALSE;

  hInst = hInstance;

  // После успешной инициализации приложения создаем
  // главное окно приложения
  hwndMain = CreateWindow(
    szClassName,         // имя класса окна
    szWindowTitle,       // заголовок окна
    WS_OVERLAPPEDWINDOW, // стиль окна
    CW_USEDEFAULT,       // задаем размеры и расположение
    CW_USEDEFAULT,       // окна, принятые по умолчанию 
    CW_USEDEFAULT,
    CW_USEDEFAULT,
    0,                   // идентификатор родительского окна
    0,                   // идентификатор меню
    hInstance,           // идентификатор приложения
    NULL);               // указатель на дополнительные
			 // параметры

  // Если создать окно не удалось, завершаем приложение
  if(!hwndMain)
    return FALSE;

  // Рисуем главное окно
  ShowWindow(hwndMain, nCmdShow);
  UpdateWindow(hwndMain);

  // Создаем кнопку
  hButton1 = CreateWindow("button", "About...",
    WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
    20, 20,
    90, 30,
    hwndMain,
    (HMENU) IDB_Button1,
    hInstance, NULL);

  if(!hButton1)
    return FALSE;

  // До запуска цикла обработки сообщений
  // идентификатор диалоговой панели должен
  // быть равен 0, т. к. панель еще не создана 
  hwndDlg = (HWND)0;

  // Запускаем цикл обработки сообщений
  while(GetMessage(&msg, 0, 0, 0))
  {
    // Выделяем сообщения для диалоговой панели,
    // если эта панель уже создана
    if(hwndDlg == 0 || !IsDialogMessage(hwndDlg, &msg))
    {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
    }
  }
  return msg.wParam;
}

// =====================================
// Функция InitApp
// Выполняет регистрацию класса окна
// =====================================

BOOL
InitApp(HINSTANCE hInstance)
{
  ATOM aWndClass; // атом для кода возврата
  WNDCLASS wc;    // структура для регистрации
                  // класса окна
  wc.style = 0;
  wc.lpfnWndProc = (WNDPROC) WndProc;
  wc.cbClsExtra = 0;
  wc.cbWndExtra = 0;
  wc.hInstance = hInstance;
  wc.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wc.hCursor = LoadCursor(NULL, IDC_ARROW);
  wc.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wc.lpszMenuName = (LPSTR)NULL;
  wc.lpszClassName = (LPSTR)szClassName;

  // Регистрация класса
  aWndClass = RegisterClass(&wc);

  return (aWndClass != 0);
}

// =====================================
// Функция WndProc
// =====================================

LRESULT CALLBACK _export
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
  static DLGPROC lpfnDlgProc;

  switch (msg)
  {
    case WM_COMMAND:
    {
      // Если нажата кнопка, выводим
      // диалоговую панель
      if(wParam == IDB_Button1)
      {
        // Переходник для функции диалоговой панели
        lpfnDlgProc = (DLGPROC)MakeProcInstance((FARPROC)DlgProc, hInst);

        // Создаем немодальную диалоговую панель
        hwndDlg = CreateDialog(hInst, "DIALOG_OK", hwnd, lpfnDlgProc);
      }
      return 0;
    }

    case WM_DESTROY:
    {
      // Удаляем диалоговую панель
      DestroyWindow(hwndDlg);

      PostQuitMessage(0);
      return 0;
    }
  }
  return DefWindowProc(hwnd, msg, wParam, lParam);
}

// =====================================
// Функция DldProc
// =====================================
#pragma argsused

BOOL CALLBACK _export
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
  switch(msg)
  {
    // Инициализация диалоговой панели
    case WM_INITDIALOG:
    {
      return TRUE;
    }

    case WM_COMMAND:
    {
      switch(wParam)
      {
        // Сообщение от кнопки "OK"
        case IDOK:

        // Отмена диалоговой панели.
        // Это сообщение приходит, когда пользователь
        // нажимает на клавишу <Esc>
        case IDCANCEL:
        {
          // Уничтожаем диалоговую панель
          DestroyWindow(hdlg);

          // Завершаем работу приложения
          DestroyWindow(hwndMain);
          return TRUE;
        }
      }
    }
  }
  return FALSE;
}
